'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chai = require('chai');

var _immutable = require('immutable');

var _partial = require('../src/partial');

var _partial2 = _interopRequireDefault(_partial);

var _lodash = require('lodash.partial');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

describe('partial', function () {
  var TestComponent = function () {
    function TestComponent() {
      _classCallCheck(this, TestComponent);

      this.__partials__ = (0, _immutable.Map)();
      this.partial = _partial2.default.bind(this);
    }

    _createClass(TestComponent, [{
      key: 'linear',
      value: function linear(a, b, c) {
        return a + b * c;
      }
    }, {
      key: 'partialA',
      value: function partialA(a) {
        return this.partial(this.linear, a);
      }
    }, {
      key: 'partialB',
      value: function partialB(b) {
        return this.partial(this.linear, _lodash.placeholder, b);
      }
    }, {
      key: 'partialC',
      value: function partialC(c) {
        return this.partial(this.linear, _lodash.placeholder, _lodash.placeholder, c);
      }
    }, {
      key: 'partialAB',
      value: function partialAB(a, b) {
        return this.partial(this.linear, a, b);
      }
    }, {
      key: 'partialAC',
      value: function partialAC(a, c) {
        return this.partial(this.linear, a, _lodash.placeholder, c);
      }
    }, {
      key: 'partialABC',
      value: function partialABC(a, b, c) {
        return this.partial(this.linear, a, b, c);
      }
    }]);

    return TestComponent;
  }();

  var t = new TestComponent();

  it('should return callables', function () {
    (0, _chai.expect)(t.partialA(3)(2, 3)).to.equal(9);
    (0, _chai.expect)(t.partialAB(3, 2)(3)).to.equal(9);
    (0, _chai.expect)(t.partialAC(3, 2)(3)).to.equal(9);
    (0, _chai.expect)(t.partialABC(3, 2, 3)()).to.equal(9);
  });

  it('should cache functions', function () {
    (0, _chai.expect)(t.partialA(1)).to.equal(t.partialA(1));
    (0, _chai.expect)(t.partialB(2)).to.equal(t.partialB(2));
    (0, _chai.expect)(t.partialC(3)).to.equal(t.partialC(3));

    (0, _chai.expect)(t.partialA(1)).to.not.equal(t.partialA(2));
    (0, _chai.expect)(t.partialA(1)).to.not.equal(t.partialB(1));
    (0, _chai.expect)(t.partialA(1)).to.not.equal(t.partialC(1));

    // technically same *mathematical* function, yet different objects
    (0, _chai.expect)(t.partialAB(1, 2)).to.not.equal(t.partialAC(1, 2));
  });
});